/*------------ ֹ DOM Ʈ  -------------------
1. ʿ Ŭ ߰
2.    Document ü 
3. ٱϿ ǰ ߰ addToCart() ޼ ۼ
4. õ ǰ  removeFromCart() ޼ ۼ
---------------------------------------------------*/
//1.ʿ Ŭ ߰
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.*;

public class Order{
	public static void main(String [] args){
		// ٱ ü 
		ShoppingCart Cart = new ShoppingCart("ȫ浿", "222-3333");
		
		//ǰ ߰
		Cart.addToCart("C1042", "¾  200 ʸ", "3", "2002-07-28");
		Cart.addToCart("K3702", " ī޶ ͸", "2", "2002-07-28");

		//ǰ 
		Cart.removeFromCart("1");

		// XML   Ȯ
		System.out.println(Cart.xmlDoc.getDocumentElement().toString());
	}
}

class ShoppingCart {
	//ֹ  Է Document ü 
	public Document xmlDoc = null;

	//2.    Document ü 
	public ShoppingCart(String name, String phone){
		try{
			// Document ü 
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			xmlDoc = builder.newDocument();

		}catch(Exception e){
			e.printStackTrace(System.err);	
		}
		
		//Ʈ  
		Element root = xmlDoc.createElement("order");

		//  
		Element customer = xmlDoc.createElement("customer");
		customer.setAttribute("name", name);
		customer.setAttribute("phone", phone);

		//Ʈ ҿ ߰
		root.appendChild(customer);
		xmlDoc.appendChild(root);

	}

	//3. ǰ   <item>  ߰
	public void addToCart(String pCode, String pName, String pQuantity, String pDate){

		//Ʈ  Ȯ
		Element root = xmlDoc.getDocumentElement();

		//item  
		Element item = xmlDoc.createElement("item");

		//ֹ ǰ id ã
		int itemNo = xmlDoc.getElementsByTagName("item").getLength() + 1;
		item.setAttribute("id", Integer.toString(itemNo));

		//ǰڵ  
		Element code = xmlDoc.createElement("productCode");
		//ǰڵ  ߰
		code.appendChild(xmlDoc.createTextNode(pCode));

		//ǰ  
		Element name = xmlDoc.createElement("productName");
		//ǰ̸  ߰
		name.appendChild(xmlDoc.createTextNode(pName));

		//  
		Element quan = xmlDoc.createElement("quantity");
		//  ߰
		quan.appendChild(xmlDoc.createTextNode(pQuantity));
	
		//ֹ  
		Element date = xmlDoc.createElement("date");
		//ֹ  ߰
		date.appendChild(xmlDoc.createTextNode(pDate));


		//item ҿ ֹ  ߰
		item.appendChild(code);
		item.appendChild(name);
		item.appendChild(quan);
		item.appendChild(date);

		//Ʈ ҿ item  ߰
		root.appendChild(item);

	}

	//4.id شϴ <item>  
	public void removeFromCart(String value){
		//Ʈ  Ȯ
		Element root = xmlDoc.getDocumentElement();

		//item Ҹ  ˻Ͽ NodeList 
		NodeList items = xmlDoc.getElementsByTagName("item");

		//NodeList    鼭
		for(int i = 0; i < items.getLength(); i++){

			String idValue = ((Element)items.item(i)).getAttribute("id");
			// ϰ ϴ id   item Ҹ ã
			if( idValue.equals(value)){
				//Ʈ ҿ  ó
				root.removeChild(items.item(i));
			}
		}
	}
}
