/*-----------------------DOM ̿ XSLT μ-------------------
1. ʿ Ŭ Ʈ
2. DocumentBuilderFactory ü 
3. DocumentBuilder ӽ̽ ν  ֵ
   DocumentBuilderFactory.setNamespaceAware(true) 
4. DocumentBuilder ü   XML / XSLT  ĽϿ Document ü 
5. Document ü  XML / XSLT  DOMSource ü 
6. ȯ   DOMResult ü 
7. XSLT μ Transformer ü  
8. Transformer.transform() ޼带 ̿Ͽ XSLT μ 
9. ȯ   DOMResult ü Document ü ĳ  ļ ۾ 
------------------------------------------------------------------*/

//1.
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.Templates;

import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.dom.DOMResult;

import org.w3c.dom.Node;
import org.w3c.dom.Document;

public class simpleDOM{

  public static void main(String [] args){
    DOMSource xmlSource = null;
    DOMSource xslSource = null; 
    //6.
    DOMResult result = new DOMResult();

    try{
      //2.
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

      //3..
      factory.setNamespaceAware(true);

      //4.
      DocumentBuilder builder = factory.newDocumentBuilder();

      //5
      Document xmlDoc = builder.parse("PhysicalCheck.xml");
      xmlSource = new DOMSource(xmlDoc);

      Document xslDoc = builder.parse("PhysicalCheck.xsl");
      xslSource = new DOMSource(xslDoc);

      //7.
      Transformer transformer = TransformerFactory.newInstance().newTransformer(xslSource);

      //8.
      transformer.transform(xmlSource, result);

    }catch(Exception e){
	e.printStackTrace(System.err);
    }

    //9.
    Document ResultDoc = (Document)result.getNode();

    System.out.println(ResultDoc.getDocumentElement());
  }
};
